
//*************************************************************************
// LED-Atomium
//
// Steffen Mller wrote this file for 
// http://www.mikrocontrollerspielwiese.de 
//
// license: GPL (http://www.gnu.org/licenses/gpl.txt)
//
// have fun!
//*************************************************************************


#define kernaus  (PORTB |= _BV(PB3))
#define kernan  (PORTB &= ~_BV(PB3))

#define E1aus  (PORTB |= _BV(PB0))
#define E1an  (PORTB &= ~_BV(PB0))

#define E2aus  (PORTB |= _BV(PB1))
#define E2an  (PORTB &= ~_BV(PB1))

#define E3aus  (PORTB |= _BV(PB2))
#define E3an  (PORTB &= ~_BV(PB2))


//**************************************************************************
#include <avr/io.h>
#define F_CPU 1500000UL  // 1 MHz
#include <util/delay.h>

//**************************************************************************

int main(void){
	
	DDRB = DDRB | _BV(PB0) | _BV(PB1) | _BV(PB2) | _BV(PB3);
	
	PORTB = PORTB | _BV(PB0) | _BV(PB1) | _BV(PB2) | _BV(PB3);//alle LEDs aus;
	
	int a;		
       
	
	
	
	while (1) {
		
		a=4;
		while (a) {
			kernan; 
			_delay_ms(255);	_delay_ms(255);
			kernaus; 
			_delay_ms(255); 	_delay_ms(255);
			a--;
		}
		
		
		
		a=20;
		while (a) {kernan; _delay_ms(12); kernaus; _delay_ms(100); a--;}
		
		
		
		kernan;
		a=20; 
		while (a) {
			E1an; _delay_ms(130); E1aus;
			E2an; _delay_ms(130); E2aus;
			E3an; _delay_ms(130); E3aus;
			a--;
		}
		
		
		
		a=20;
		while (a) {
			E3an; _delay_ms(100); E3aus;	PORTB ^=_BV(PB3);
			E2an; _delay_ms(100); E2aus;	PORTB ^=_BV(PB3);
			E1an; _delay_ms(100); E1aus;	PORTB ^=_BV(PB3);
			a--;
		}
		
		_delay_ms(255);_delay_ms(255);_delay_ms(255);_delay_ms(255);
	   
	}
  
   return(0);
}
//**************************************************************************





